#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_SplashScreenCFG.h"
#include "FileEncrypt.h"
std::auto_ptr<M_SplashScreenCFG> M_SplashScreenCFG::msSingleton(nullptr);

int M_SplashScreenCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_SplashScreenCFGData* M_SplashScreenCFG::GetData(int SplashScreenId)
{
	auto it = mMapData.find(SplashScreenId);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_SplashScreenCFGData>& M_SplashScreenCFG::GetMapData()
{
	return mMapData;
}

void M_SplashScreenCFG::Reload()
{
	mMapData.clear();
	Load();
}

void M_SplashScreenCFG::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_SplashScreenCFGData data;
		data.mSplashScreenId = element->IntAttribute("SplashScreenId");
		data.mText1 = element->Attribute("Text1");
		data.mText2 = element->Attribute("Text2");
		data.mText3 = element->Attribute("Text3");
		data.mText4 = element->Attribute("Text4");
		data.mText5 = element->Attribute("Text5");
		data.mRemark = element->Attribute("Remark");
		if (mMapData.find(data.mSplashScreenId) != mMapData.end())std::cout <<"data refind:" << data.mSplashScreenId << std::endl;
		assert(mMapData.find(data.mSplashScreenId) == mMapData.end());
		mMapData.insert(std::make_pair(data.mSplashScreenId, data));
		element = element->NextSiblingElement();
	}
}

void M_SplashScreenCFG::Load()
{
	Load("../Config/M_SplashScreenCFG.xml");
}

M_SplashScreenCFG* M_SplashScreenCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_SplashScreenCFG());
	}
	return msSingleton.get();
}
